//  -----------------------------------------------------------------------
//  Copyright 2002--2009  Alfred Steffens Jr.
//  -----------------------------------------------------------------------
//  -----------------------------------------------------------------------
//    Copying Permission:
//
//    attrk is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    attrk is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with attrk (see file called "COPYING"); if not, write to the Free
//    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
//    02111-1307  USA
//  ------------------------------------------------------------------------

void Error_Printf(char *fmt, ...);

#ifdef DEBUG
#define ERROR_NULL(p,r) {\
    if (p==NULL)\
    {\
        Error_Printf("E999: NULL pointer to %s\n", __FUNCTION__);\
        return (r);\
    }\
}
#else
#define ERROR_NULL(p,r)
#endif

#ifdef DEBUG
#define ERROR_NULL_VOID(p) {\
    if (p==NULL)\
    {\
        Error_Printf("E999: NULL pointer to %s\n", __FUNCTION__);\
        return;\
    }\
}
#else
#define ERROR_NULL_VOID(p)
#endif

#ifdef DEBUG
#define DEBUGGER(s) { Error_Printf("DEBUGGER: (%s)\n", s); }
#endif

#ifdef DEBUG
#define ERROR_RANGE(a,m,s) {\
    if (a >= m)\
        Error_Printf("E998: index %s out-of-range in %s\n", s, __FUNCTION__);\
}
#else
#define ERROR_RANGE(a,m,s)
#endif

