//  -----------------------------------------------------------------------
//  Copyright 2002--2009  Alfred Steffens Jr.
//  -----------------------------------------------------------------------
//  -----------------------------------------------------------------------
//    Copying Permission:
//
//    attrk is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation.
//
//    attrk is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with attrk (see file called "COPYING"); if not, write to the Free
//    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
//    02111-1307  USA
//  ------------------------------------------------------------------------


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdio.h>
#include <stdarg.h>
#include <defs.h>
#include <logprintf.h>
#include <msgprintf.h>

int g_message_display = MESSAGE_DISPLAY_STDOUT;
static char msg[2048];
extern void SLang_message(char *msg);

void Msg_Printf(char *fmt, ...)
{
va_list vl;

    //
    //  vl is a pointer to arguments on the function stack
    //  va_start points "vl" to the first argument that comes after "fmt"
    //
    va_start(vl, fmt);

    v_LogFile_Printf(fmt, vl);		// print to logfile

    switch (g_message_display)
    {

        case MESSAGE_DISPLAY_SLANG:
            vsprintf(msg, fmt, vl);
            SLang_message(msg);
        break;

        default:
            vfprintf(stdout, fmt, vl);	// standard output
        break;

    } // switch

    va_end(vl);
}
/************************* Msg_Printf **********************************/

