/**
 * C-code modifications Copyright (C) 2009 Alfred Steffens Jr.
 * based on TekTracker, Copyright (C) 2001 Billy Biggs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef PATBAR_H_INCLUDED
#define PATBAR_H_INCLUDED

struct PatBar {
    int pos;

    int chan;
    int row;
    int col;
    int cursor;
    int scrolltop;
};

void Init_PatBar(struct PatBar *pbar, int initchan, int startrow, int startcol);
struct PatBar *Create_PatBar(int initchan, int startrow, int startcol);
void pbar_setPosition(struct PatBar *pbar,  int newpos);
void pbar_setNote(struct PatBar *pbar, int note);
void pbar_refresh(struct PatBar *pbar);
void pbar_noteToString(char *str, int note);
void pbar_printPatLine(struct PatBar *pbar, int i);
int pbar_setCursor(struct PatBar *pbar, int newpos);
void pbar_editCursorVolume(struct PatBar *pbar,  int mod);
void pbar_toggleCursorSlide(struct PatBar *pbar);
void pbar_editPattern(struct PatBar *pbar, int mod);
int pbar_patternSet(struct PatBar *pbar);
void pbar_transposeNotes(struct PatBar *pbar, int trans);
void pbar_setPatternName(struct PatBar *pbar, const char *newname);
void pbar_toggleEndNote(struct PatBar *pbar);
void pbar_toggleChannelMute(struct PatBar *pbar);
void pbar_editMidiChannel(struct PatBar *pbar, int mod);
void pbar_editMidiPort(struct PatBar *pbar, int port);
void pbar_editChannelVolume(struct PatBar *pbar, int mod);
int pbar_getIndex(struct PatBar *pbar);
void pbar_setChannel(struct PatBar *pbar, int chan);
void pbar_setScrollTop(struct PatBar *pbar, int newpos);
void pbar_setChannelName(struct PatBar *pbar, const char *newname);
void pbar_setChannelPatch(struct PatBar *pbar, int bank, int program);
void pbar_setCursorVolume(struct PatBar *pbar,  int new_velocity);

#endif // PATBAR_H_INCLUDED
