/**
 * C-code modifications Copyright (C) 2009 Alfred Steffens Jr.
 * Copyright (C) 2001 Billy Biggs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef RTCTIMER_H_INCLUDED
#define RTCTIMER_H_INCLUDED


struct RealTimeClock {
    int rtc_fd;
    int current_hz;
    int rtc_running;
};

int Init_RealTimeClock(struct RealTimeClock *rtc);
struct RealTimeClock *Create_RealTimeClock(void);
void Delete_RealTimeClock(struct RealTimeClock *rtc);
int rtc_nextTick(struct RealTimeClock *rtc);
int rtc_setInterval(struct RealTimeClock *rtc, int hz);
int rtc_startClock(struct RealTimeClock *rtc);
int rtc_stopClock(struct RealTimeClock *rtc);

#endif // RTCTIMER_H_INCLUDED
