/**
 * C-code modifications Copyright (C) 2009 Alfred Steffens Jr.
 * based on TekTracker, Copyright (C) 2001 Billy Biggs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef SONGBAR_H_INCLUDED
#define SONGBAR_H_INCLUDED

struct SongBar {
    int chan;
    int row;
    int col;
    int cursor;
    int scrolltop;
};

void Init_SongBar(struct SongBar *sbar, int initchan, int startrow,
                  int startcol);
struct SongBar *Create_SongBar(int initchan, int startrow, int startcol);
int sbar_setCursor(struct SongBar *sbar, int newpos);
void sbar_refresh(struct SongBar *sbar);
void sbar_editPattern(struct SongBar *sbar,  int mod);
void sbar_printLine(struct SongBar *sbar, int i);
int sbar_patternSet(struct SongBar *sbar);
void sbar_setPatternName(struct SongBar *sbar, const char *newname);
void sbar_toggleChannelMute(struct SongBar *sbar);
void sbar_editMidiChannel(struct SongBar *sbar, int mod);
void sbar_editMidiPort(struct SongBar *sbar, int port);
void sbar_editChannelVolume(struct SongBar *sbar, int mod);
int sbar_getIndex(struct SongBar *sbar);
void sbar_setChannel(struct SongBar *sbar, int chan);
void sbar_setScrollTop(struct SongBar *sbar, int newpos);
void sbar_setChannelName(struct SongBar *sbar, const char *newname);
void sbar_setChannelPatch(struct SongBar *sbar, int bank, int program);

#endif // SONGBAR_H_INCLUDED
