/**
 * C-code modifications Copyright (C) 2009 Alfred Steffens Jr.
 * based on TekTracker, Copyright (C) 2001 Billy Biggs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <sched.h>
#include <ctype.h>
#include <stdio.h>
#include <fcntl.h>
#include <defs.h>
#include <errorprintf.h>
#include <xmltools.h>
#include <song.h>
#include <utils.h>

extern struct MidiControl *p_MidiControl;
extern struct Song *p_Song;

//  ------------------------------------------------------
//  (Biggs:)
//  Modified from the UNIX FAQ.  Google gave me this URL:
//  http://www.erlenstar.demon.co.uk/unix/faq_3.html
//  ------------------------------------------------------

//  -------------------------------------------------------------------------
//  Function    --  set_realtime_priority
//
//  Description
//
//  Arguments
//
//  Return
//
//  -------------------------------------------------------------------------
int set_realtime_priority( void )
{
    struct sched_param schp;

    memset( &schp, 0, sizeof( schp ) );
    schp.sched_priority = sched_get_priority_max( SCHED_FIFO );

    if (sched_setscheduler(0, SCHED_FIFO, &schp) != 0)
    {
        return -1;
    }

    return 0;
}
//  function -- set_realtime_priority
//  -------------------------------------------------------------------------

