/**                                                                             
 * Copyright (C) 2009 Alfred Steffens Jr.
 *
 * This program is free software; you can redistribute it and/or modify         
 * it under the terms of the GNU General Public License as published by         
 * the Free Software Foundation; either version 2 of the License, or (at        
 * your option) any later version.                                              
 *                                                                              
 * This program is distributed in the hope that it will be useful, but          
 * WITHOUT ANY WARRANTY; without even the implied warranty of                   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            
 * General Public License for more details.                                     
 *                                                                              
 * You should have received a copy of the GNU General Public License            
 * along with this program; if not, write to the Free Software                  
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                    
 */                                                                             

#define MAX_XMLTOKEN_LENGTH    64
#define MAX_XMLATTR_LENGTH     32
#define TAG_TYPE_OPEN           1
#define TAG_TYPE_SINGLE         2
#define TAG_TYPE_CLOSE          3

char *Get_Leading_Token(char *str, char *seps);
char *Get_Final_Token(char *str, char *seps);
char *convert_tolower(char *str);


struct StrList {
    int type;
    char *field;
    struct StrList *next;
};

struct StrList *Create_StrList(char *field);
void Delete_StrList(struct StrList *slist);
struct StrList *Split_String(char *str, char *seps);
struct StrList *Find_Matching_Tag(struct StrList *slist);


struct XmlAttr {
    int type;
    char name[MAX_XMLATTR_LENGTH];
    char value[MAX_XMLATTR_LENGTH];
    struct XmlAttr *next;
};

struct XmlAttr *Create_XmlAttr(void);
void Delete_XmlAttr(struct XmlAttr *attr);
struct XmlAttr *Get_Attributes(char *str);
char *Get_XmlAttr_Value(struct XmlAttr *xmlattr, char *name);
int Get_Integer_XmlAttr(struct XmlAttr *xmlattr, char *attrname, int *result);
int Get_String_XmlAttr(struct XmlAttr *xmlattr, char *attrname, char *result);


struct XmlToken {
    int type;
    char name[MAX_XMLTOKEN_LENGTH];
    struct XmlAttr *attr;
    struct XmlToken *next;
    struct XmlToken *child;
};

struct XmlToken *Create_XmlToken(void);
void Delete_XmlToken(struct XmlToken *token);
struct XmlToken *ParseXml(struct StrList *slist);
void LogXml(struct XmlToken *xmltok);
struct XmlToken *Read_FileBuffer(char *filebuffer);

